Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 280341 - app-portage/gentoolkit: revdep-rebuild fails to find owning package of some files in /usr/lib64
Summary: app-portage/gentoolkit: revdep-rebuild fails to find owning package of some f...
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: New packages (show other bugs)
Hardware: AMD64 Linux
: High normal with 1 vote (vote)
Assignee: Portage Tools Team
URL:
Whiteboard:
Keywords: InVCS
: 282457 287664 (view as bug list)
Depends on:
Blocks: 237964 305793
  Show dependency tree
 
Reported: 2009-08-04 17:07 UTC by Cyp
Modified: 2017-04-18 10:31 UTC (History)
6 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
/var/cache/revdep-rebuild/0_env.rr (0_env.rr,1.60 KB, text/plain)
2009-08-27 18:18 UTC, Cyp
Details
/var/cache/revdep-rebuild.tar.bz2 (revdep-rebuild.tar.bz2,128.69 KB, application/x-bzip-compressed-tar)
2009-08-29 19:34 UTC, Cyp
Details
failed revdep-rebuild files (revdep-rebuild-marios.tgz,120.54 KB, application/octet-stream)
2009-08-29 21:26 UTC, Marios Andreopoulos
Details
revdep-rebuild-gcc-upgrade-failed-files.txt.bz2 (revdep-rebuild-gcc-upgrade-failed-files.txt.bz2,1.98 KB, application/x-bzip2)
2017-04-18 10:31 UTC, i.Dark_Templar
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Cyp 2009-08-04 17:07:14 UTC
revdep-rebuild fails to find files belonging to packages which put libraries in /usr/lib64. Since /usr/lib64 is a symlink to /usr/lib, there shouldn't be a difference between /usr/lib/libblah.la and /usr/lib64/libblah.la.

# revdep-rebuild
...
 * Found some broken files that weren't associated with known packages
 * The broken files are:
 *   /usr/lib/gnash/libgnashcore.la
...
# equery b /usr/lib/libgnashcore.la
[ Searching for file(s) /usr/lib/libgnashcore.la in *... ]
# equery b libgnashcore.la
[ Searching for file(s) libgnashcore.la in *... ]
www-plugins/gnash-0.8.4 (/usr/lib64/gnash/libgnashcore.la)
#
Comment 1 James Earl Spahlinger 2009-08-10 00:43:25 UTC
Please paste the output of 'emerge --info' into a bugzilla comment to assist the maintainers in resolving this issue

Comment 2 Cyp 2009-08-10 05:25:18 UTC
(In reply to comment #1)
> Please paste the output of 'emerge --info' into a bugzilla comment to assist
> the maintainers in resolving this issue

Portage 2.1.6.13 (default/linux/amd64/2008.0/desktop, gcc-4.3.4, glibc-2.9_p20081201-r2, 2.6.30-gentoo-r3 x86_64)
=================================================================
System uname: Linux-2.6.30-gentoo-r3-x86_64-Intel-R-_Core-TM-2_Quad_CPU_Q6600_@_2.40GHz-with-gentoo-1.12.11.1
Timestamp of tree: Sun, 09 Aug 2009 14:30:01 +0000
ccache version 2.4 [disabled]
app-shells/bash:     3.2_p39
dev-java/java-config: 2.1.8-r1
dev-lang/python:     2.5.4-r3, 2.6.2-r1
dev-python/pycrypto: 2.0.1-r8
dev-util/ccache:     2.4-r7
dev-util/cmake:      2.6.4
sys-apps/baselayout: 1.12.11.1
sys-apps/sandbox:    1.6-r2
sys-devel/autoconf:  2.13, 2.63-r1
sys-devel/automake:  1.4_p6, 1.5, 1.7.9-r1, 1.8.5-r3, 1.9.6-r2, 1.10.2
sys-devel/binutils:  2.18-r3
sys-devel/gcc-config: 1.4.1
sys-devel/libtool:   1.5.26
virtual/os-headers:  2.6.27-r2
ACCEPT_KEYWORDS="amd64"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=core2 -O2 -pipe -g"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/lib/X11/xkb /usr/share/config /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/php/apache2-php5/ext-active/ /etc/php/cgi-php5/ext-active/ /etc/php/cli-php5/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c /etc/udev/rules.d"
CXXFLAGS="-march=core2 -O2 -pipe -g"
DISTDIR="/usr/portage/distfiles"
FEATURES="distlocks fixpackages parallel-fetch protect-owned sandbox sfperms splitdebug strict unmerge-orphans userfetch"
GENTOO_MIRRORS=" http://gentoo.tiscali.nl/ http://mirrors.sec.informatik.tu-darmstadt.de/gentoo/ #http://pandemonium.tiscali.de/pub/gentoo/ http://ds.thn.htu.se/linux/gentoo"
LANG="en_US.UTF8"
LDFLAGS="-Wl,-O1"
LINGUAS="en da pt_BR"
MAKEOPTS="-j4"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage /usr/local/portage/layman/java-overlay /usr/local/portage/layman/science"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="3dnow 3dnowext X a52 aac aalib acl acpi alisp alsa amd64 apache2 ares bash-completion bazaar bdf berkdb bluetooth branding bzip2 cairo cdda cdr cli cracklib crypt cups curl cvs d dbus djvu dk doc dri dvd dvdr dvipdfm editor eds emboss emoticons-manager encode esd evo exif fam ffmpeg firefox flac foomaticdb fortran gcj gd gdbm gif git glitz gmp gnutls gpm graphite graphviz gstreamer gtk hal iconv imlib irda isdnlog ithreads jadetex java jpeg jpeg2k kde kerberos kpathsea ldap libcaca libnotify live logitech-mouse lzma mad mercurial midi mikmod mjpeg mmx mmxext mng mp2 mp3 mp4 mpeg msn mudflap multilib mysql ncurses network nls nodrm nptl nptlonly nsplugin objc objc++ objc-gc offensive ogg opengl openmp oss pam pcre pdf perl plotutils png povray ppds pppd python qt3 qt3support qt4 quicktime readline reflection rle samba scanner sdl se_swedb server session sift solver speex spell spl sse sse2 ssl ssse3 startup-notification subversion svg sysfs tcpd tga theora threads tiff timidity tk tokenizer truetype unicode usb v4l v4l2 vcd vorbis webkit wma wxwidgets x264 xcomposite xine xml xorg xscreensaver xulrunner xv xvid xvmc zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic auth_digest authn_anon authn_dbd authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock dbd deflate dir disk_cache env expires ext_filter file_cache filter headers ident imagemap include info log_config logio mem_cache mime mime_magic negotiation proxy proxy_ajp proxy_balancer proxy_connect proxy_http rewrite setenvif so speling status unique_id userdir usertrack vhost_alias" ELIBC="glibc" INPUT_DEVICES="evdev keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="en da pt_BR" USERLAND="GNU" VIDEO_CARDS="s3 v4l vesa vga via i810 intel"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, FFLAGS, INSTALL_MASK, LC_ALL, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 3 Marios Andreopoulos 2009-08-27 11:00:29 UTC
I also have this problem. As a workaround I added /usr/lib64 to the paths revdep-rebuild is searching.

I am running an ~amd64 system.
Comment 4 Paul Varner (RETIRED) gentoo-dev 2009-08-27 13:28:37 UTC
Without the full output, I can't tell if this is Bug 93574 or a separate issue.  Did revdep-rebuild find /usr/lib64/gnash/libgnashcore.la and rebuild gnash?
Comment 5 Cyp 2009-08-27 14:24:49 UTC
(In reply to comment #4)
> Without the full output, I can't tell if this is Bug 93574 or a separate issue.
>  Did revdep-rebuild find /usr/lib64/gnash/libgnashcore.la and rebuild gnash?

It didn't rebuild gnash. (I rebuilt it manually.)
Comment 6 Paul Varner (RETIRED) gentoo-dev 2009-08-27 16:17:41 UTC
Please run revdep-rebuild --ignore --keep-temp --pretend as root and attach /var/cache/revdep-rebuild/0_env.rr to this case. Also, add the output of ls -ld /usr/lib*
Comment 7 Cyp 2009-08-27 18:18:45 UTC
Created attachment 202417 [details]
/var/cache/revdep-rebuild/0_env.rr

~ # ls -ld /usr/lib*
drwxr-xr-x 164 root root 143360 2009-08-27 09:55 /usr/lib
drwxr-xr-x  18 root root  20480 2009-08-27 09:52 /usr/lib32
lrwxrwxrwx   1 root root      8 2008-11-14 23:37 /usr/lib64 -> /usr/lib
drwxr-xr-x  11 root root   4096 2009-08-04 15:37 /usr/libexec
Comment 8 Marios Andreopoulos 2009-08-27 22:24:48 UTC
I have the problem as described in the title but not with gnash. I believe it is more generic. As a workaround I actually added /usr/lib64/ to revdep-rebuild SEARCH_DIRS.

Now what may be interesting in this case is:

Without trailing slash (same as /usr/lib*) doesn't work and we have:
$ ls -ld /usr/lib64
lrwxrwxrwx 1 root root 3 Dec 24  2007 /usr/lib64 -> lib

With trailing slash it works and we have:
$ ls -ld /usr/lib64/
drwxr-xr-x 261 root root 253952 Aug 27 16:13 /usr/lib64/

For example, with default settings, revdep-rebuilds finds libkipiplugins.so.1.0.0 broken and when trying to find the owner it gives:
!!! /usr/lib/libkipiplugins.so.1.0.0 not owned by any package is broken !!!
*   /usr/lib/libkipiplugins.so.1.0.0 -> (none)

Indeed, equery gives no results:
$ equery b /usr/lib/libkipiplugins.so.1.0.0
* Searching for /usr/lib/libkipiplugins.so.1.0.0 ...

What we should search for is:
$ equery b /usr/lib64/libkipiplugins.so.1.0.0
* Searching for /usr/lib64/libkipiplugins.so.1.0.0 ...
media-plugins/kipi-plugins-0.5.0 (/usr/lib64/libkipiplugins.so.1.0.0)

I can provide the 0_env.rr files if needed.
Comment 9 Cyp 2009-08-28 06:13:45 UTC
(In reply to comment #8)
> I have the problem as described in the title but not with gnash. I believe it
> is more generic. As a workaround I actually added /usr/lib64/ to revdep-rebuild
> SEARCH_DIRS.

Yes, it is more generic – gnash just happened to be a package failing to be rebuilt, at the time when I got around to reporting the bug.

> Now what may be interesting in this case is:
...
> lrwxrwxrwx 1 root root 3 Dec 24  2007 /usr/lib64 -> lib
...
> drwxr-xr-x 261 root root 253952 Aug 27 16:13 /usr/lib64/

Without trailing slash, ls -ld gives information about the file, which is a symbolic link in this case. With the trailing slash, ls -ld follows the symbolic link, and gives information about /usr/lib/ (or complains, if /usr/lib/ isn't a directory). Using ls -ldL always follows symbolic links.

...
> $ equery b /usr/lib/libkipiplugins.so.1.0.0
...
> $ equery b /usr/lib64/libkipiplugins.so.1.0.0
...

Searching with "equery b libkipiplugins.so.1.0.0" would find it whether it happens to be recorded as installed in /usr/lib/ or in /usr/lib64/.
In my opinion, equery (and revdep-rebuild) ought to be able to find both /usr/lib/libkipiplugins.so.1.0.0 and /usr/lib64/libkipiplugins.so.1.0.0, since both are actually the same file on the drive. (I don't know if that would be practical.)
Comment 10 Marios Andreopoulos 2009-08-28 08:33:19 UTC
Searching with just the filename could return more than one package since every package has not to overwrite other packages' files. There isn't a rule to give absolutely unique names to its files.

What revdep-rebuild (and propably equery) does to find the owner of a file is to grep the filename with its full path in the /var/db/pkg folder.
Amog others, there is stored for each emerged ebuild a list of the files it installed. In these lists each installed file appears only once and in our case depending if you search for libraries inside lib or lib64 could return or not results.

Some ebuilds install their libraries in /usr/lib and some in /usr/lib64. It may be the same directory but searching in /var/db/pkg/category/name/CONTENTS only one of these paths will return results.
Comment 11 Paul Varner (RETIRED) gentoo-dev 2009-08-28 18:46:31 UTC
Okay, I have not been able to reproduce this on on my AMD64 system.  The next time it fails to not find and emerge a package, please attach the full output from revdep-rebuild and any files that are in /var/cache/revdep-rebuild.
Comment 12 Cyp 2009-08-29 19:34:30 UTC
Created attachment 202629 [details]
/var/cache/revdep-rebuild.tar.bz2

I broke /usr/lib/gnash/libgnashcore.la, so revdep-rebuild would have something to (not) find.
/var/cache/revdep-rebuild/* attached.

Full output: (I masked gcc:4.1, since portage wanted to recompile it all the time, but recompiling it failed. Maybe I'll just uninstall it some time...)

# revdep-rebuild -- -av
 * Configuring search environment for revdep-rebuild
 * Environment mismatch from previous run, deleting temporary files...

 * Checking reverse dependencies
 * Packages containing binaries and libraries broken by a package update
 * will be emerged.

 * Collecting system binaries and libraries
 * Generated new 1_files.rr
 * Collecting complete LD_LIBRARY_PATH
 * Generated new 2_ldpath.rr
 * Checking dynamic linking consistency
[ 13% ]  *   broken /usr/bin/rosegarden (requires liblo.so.0)
 *   broken /usr/bin/rosegardensequencer (requires liblo.so.0)
[ 68% ]  *   broken /usr/lib/gcc/x86_64-pc-linux-gnu/4.1.2/libgcjawt.la (requires /usr/lib/gcc/x86_64-pc-linux-gnu/4.3.4/lib-gnu-java-awt-peer-gtk.la)
[ 72% ]  *   broken /usr/lib/gnash/libgnashcore.la (requires /usr/lib64/libMissingLibrary.la)
[ 100% ]
 * Generated new 3_broken.rr
 * Assigning files to packages
 *   /usr/bin/rosegarden -> media-sound/rosegarden
 *   /usr/bin/rosegardensequencer -> media-sound/rosegarden
 *   /usr/lib/gcc/x86_64-pc-linux-gnu/4.1.2/libgcjawt.la -> sys-devel/gcc
 *  !!! /usr/lib/gnash/libgnashcore.la not owned by any package is broken !!!
 *   /usr/lib/gnash/libgnashcore.la -> (none)
 * Generated new 4_raw.rr and 4_owners.rr
 * Cleaning list of packages to rebuild
 * Generated new 4_pkgs.rr
 * Assigning packages to ebuilds
 * Generated new 4_ebuilds.rr
 * Evaluating package order
 * Generated new 5_order.rr
 * All prepared. Starting rebuild
emerge --oneshot -av media-sound/rosegarden:0
sys-devel/gcc:4.1
..........

These are the packages that would be merged, in order:

Calculating dependencies... done!

!!! All ebuilds that could satisfy "sys-devel/gcc:4.1" have been masked.
!!! One of the following masked packages is required to complete your request:
- sys-devel/gcc-4.1.2 (masked by: package.mask)

For more information, see the MASKED PACKAGES section in the emerge
man page or refer to the Gentoo Handbook.

 *
 * revdep-rebuild failed to emerge all packages.
 * you have the following choices:
 * - If emerge failed during the build, fix the problems and re-run revdep-rebuild.
 * - Use /etc/portage/package.keywords to unmask a newer version of the package.
 *   (and remove 5_order.rr to be evaluated again)
 * - Modify the above emerge command and run it manually.
 * - Compile or unmerge unsatisfied packages manually,
 *   remove temporary files, and try again.
 *   (you can edit package/ebuild list first)
 *
 * To remove temporary files, please run:
 * rm /var/cache/revdep-rebuild/*.rr
 * Found some broken files that weren't associated with known packages
 * The broken files are:
 *   /usr/lib/gnash/libgnashcore.la
#
Comment 13 Marios Andreopoulos 2009-08-29 21:26:20 UTC
Created attachment 202641 [details]
failed revdep-rebuild files

I attached the revdep-rebuild enviroment files from a case where it failed to find the owners of some files.
In the archive I also added my emerge --info output.
Comment 14 Christian Ruppert (idl0r) archtester Gentoo Infrastructure gentoo-dev Security 2009-09-30 18:59:25 UTC
*** Bug 282457 has been marked as a duplicate of this bug. ***
Comment 15 Cyp 2009-11-07 07:10:52 UTC
I tried applying:
http://sources.gentoo.org/viewcvs.py/gentoolkit/trunk/gentoolkit/bin/revdep-rebuild?r1=602&r2=696
to my revdep-rebuild.

# revdep-rebuild --library /usr/lib/libjpeg.so.62 -- -av
 * Configuring search environment for revdep-rebuild

 * Checking reverse dependencies
 * Packages containing binaries and libraries using /usr/lib/libjpeg.so.62
 * will be emerged.

 * Collecting system binaries and libraries
 * Found existing 1_files.rr
 * Checking dynamic linking
 * Found existing 3_broken.rr.
 * Assigning files to packages
 *  !!! /usr/lib/imlib2/loaders/jpeg.so not owned by any package is broken !!!
 *   /usr/lib/imlib2/loaders/jpeg.so -> (none)
 *  !!! ...

As far as I understand, the patch helps in the case that a library is emerged in /usr/lib and linked to in /usr/lib64, but not in the reverse case.

I've found that 'qfile -qeC' works for me (and is several times faster), so for now, I've edited my /usr/bin/revdep-rebuild and replaced the get_file_owner function with:

get_file_owner() {
        local IFS=$'\n'
        qfile -qeC -- "${*}"
}

I think the above would be even faster, if get_file_owner was called with all files at once.
Comment 16 Christian Ruppert (idl0r) archtester Gentoo Infrastructure gentoo-dev Security 2009-12-10 21:57:12 UTC
http://sources.gentoo.org/viewcvs.py/gentoolkit?rev=717&view=rev contains another workaround.
Comment 17 Paul Varner (RETIRED) gentoo-dev 2010-01-07 16:25:30 UTC
Released in gentoolkit-0.3.0_rc8
Comment 18 Paul Varner (RETIRED) gentoo-dev 2010-01-07 17:11:03 UTC
*** Bug 287664 has been marked as a duplicate of this bug. ***
Comment 19 Paul Varner (RETIRED) gentoo-dev 2010-02-16 21:10:44 UTC
*** Bug 305427 has been marked as a duplicate of this bug. ***
Comment 20 Jason A. Donenfeld archtester Gentoo Infrastructure gentoo-dev Security 2016-02-18 11:15:54 UTC
Reopening this bug. It was fixed in the now old version of revdep-rebuild here:
https://gitweb.gentoo.org/proj/gentoolkit.git/tree/bin/revdep-rebuild.sh#n282

	# Workaround for bug 280341
	mlib=$(echo ${*}|sed 's:/lib/:/lib64/:')
	[[ "${*}" == "${mlib}" ]] && mlib=$(echo ${*}|sed 's:/lib64/:/lib/:')

However, it does not appear that such wisdom has made it to the new python based revdep-rebuild.

# revdep-rebuild -- -a
 * This is the new python coded version
 * Please report any bugs found using it.
 * The original revdep-rebuild script is installed as revdep-rebuild.sh
 * Please files bugs at: https://bugs.gentoo.org/
 * Collecting system binaries and libraries
 * Checking dynamic linking consistency
 * Assign files to packages

 !!! Broken orphaned files: No installed package was found for the following:
        * /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libatomic.so.1.1.0
        * /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libasan.so.2.0.0
        * /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libgomp.so.1.0.0
        * /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libgfortran.so.3.0.0
        * /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libstdc++.so.6.0.21
        * /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libitm.so.1.0.0
        * /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libubsan.so.0.0.0



However, interestingly this problem also finds itself in equery and qfile:

zx2c4@thinkpad ~ $ equery b /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libubsan.so.0.0.0
 * Searching for /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libubsan.so.0.0.0 ... 
zx2c4@thinkpad ~ $ equery b /usr/lib/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libubsan.so.0.0.0
 * Searching for /usr/lib/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libubsan.so.0.0.0 ... 
cross-armv7a-hardfloat-linux-gnueabi/gcc-5.3.0 (/usr/lib/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libubsan.so.0.0.0)
zx2c4@thinkpad ~ $ qfile /usr/lib64/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libubsan.so.0.0.0
zx2c4@thinkpad ~ $ qfile /usr/lib/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libubsan.so.0.0.0
cross-armv7a-hardfloat-linux-gnueabi/gcc (/usr/lib/gcc/armv7a-hardfloat-linux-gnueabi/5.3.0/libubsan.so.0.0.0)
Comment 21 Brian Dolbec gentoo-dev 2016-02-18 16:11:31 UTC
The reason for both to fail is both equery and the new python revdep use portage to find the owner pkgs.  So, this is a failing in portage itself.

So, this must be a crossdev issue that is not recording the contents correctly.
Comment 22 i.Dark_Templar 2017-04-18 10:31:01 UTC
Created attachment 470306 [details]
revdep-rebuild-gcc-upgrade-failed-files.txt.bz2

I've tried to upgrade gcc to 5.4.0 today, and ran revdep-rebuild as instructed in gentoo news. It failed to resolve files belonging to sys-devel/llvm:4 and sys-devel/clang:4. Full list of files is in attachment.

For example:
$ equery b /usr/lib64/llvm/4/lib64/libLLVMX86Info.so.4.0.0
 * Searching for /usr/lib64/llvm/4/lib64/libLLVMX86Info.so.4.0.0 ... 
$ equery b /usr/lib/llvm/4/lib64/libLLVMX86Info.so.4.0.0
 * Searching for /usr/lib/llvm/4/lib64/libLLVMX86Info.so.4.0.0 ... 
sys-devel/llvm-4.0.0-r2 (/usr/lib/llvm/4/lib64/libLLVMX86Info.so.4.0.0)


$ emerge --info gentoolkit
Portage 2.3.3 (python 2.7.12-final-0, default/linux/amd64/13.0/desktop, gcc-5.4.0, glibc-2.23-r3, 4.9.16-gentoo.48 x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-4.9.16-gentoo.48-x86_64-Intel-R-_Core-TM-_i5-6500_CPU_@_3.20GHz-with-gentoo-2.3
KiB Mem:    16387796 total,   3252024 free
KiB Swap:    4192252 total,   4192252 free
Timestamp of repository gentoo: Tue, 18 Apr 2017 00:45:01 +0000
sh bash 4.3_p48-r1
ld GNU ld (Gentoo 2.26.1 p1.0) 2.26.1
app-shells/bash:          4.3_p48-r1::gentoo
dev-lang/perl:            5.24.1-r1::gentoo
dev-lang/python:          2.7.12::gentoo, 3.4.5::gentoo, 3.5.3::gentoo
dev-util/cmake:           3.7.2::gentoo
dev-util/pkgconfig:       0.28-r2::gentoo
sys-apps/baselayout:      2.3::gentoo
sys-apps/openrc:          0.25::gentoo                                                                                                                                              
sys-apps/sandbox:         2.10-r3::gentoo                                                                                                                                           
sys-devel/autoconf:       2.13::gentoo, 2.69::gentoo                                                                                                                                
sys-devel/automake:       1.11.6-r1::gentoo, 1.15::gentoo                                                                                                                           
sys-devel/binutils:       2.26.1::gentoo                                                                                                                                            
sys-devel/gcc:            4.9.4::gentoo, 5.4.0-r3::gentoo                                                                                                                           
sys-devel/gcc-config:     1.7.3::gentoo                                                                                                                                             
sys-devel/libtool:        2.4.6-r3::gentoo                                                                                                                                          
sys-devel/make:           4.2.1::gentoo                                                                                                                                             
sys-kernel/linux-headers: 4.4::gentoo (virtual/os-headers)                                                                                                                          
sys-libs/glibc:           2.23-r3::gentoo                                                                                                                                           
Repositories:                                                                                                                                                                       

gentoo
    location: /usr/portage
    sync-type: webrsync
    sync-uri: https://mirror.yandex.ru/gentoo-distfiles/
    priority: -1000

dt-overlay-patches
    location: /var/lib/layman/dt-overlay-patches
    sync-type: laymansync
    sync-uri: https://github.com/iDarkTemplar/dt-overlay-patches.git
    masters: gentoo
    priority: 50

dt-overlay-private
    location: /var/lib/layman/dt-overlay-private
    sync-type: laymansync
    sync-uri: git://private-git.templar-local/private/dt-overlay-private
    masters: gentoo
    priority: 50

dt-overlay-public
    location: /var/lib/layman/dt-overlay-public
    sync-type: laymansync
    sync-uri: https://github.com/iDarkTemplar/dt-overlay-public.git
    masters: gentoo
    priority: 50

rion
    location: /var/lib/layman/rion
    sync-type: laymansync
    sync-uri: https://github.com/rion-overlay/rion-overlay.git
    masters: gentoo
    priority: 50

Installed sets: @archive-tools, @bootloader, @devel-packages, @devel-tools, @devel-tools-x11, @filesystem-tools, @filesystem-tools-android, @fonts, @fortune, @hardware-tools, @hardware-tools-x11, @image-tools, @kde5, @lxc, @mail-server, @media, @media-converters, @network-analyzers, @network-extras, @network-tools, @network-tools-extra, @opengl-devel, @opengl-utils, @pidgin, @portage-tools, @portage-tools-dev, @portage-tools-extra, @power-utils, @printers, @psi, @qmmp, @splash, @system-admin-utils, @system-admin-utils-extra, @system-daemons, @system-utils, @system-utils-extra, @text-utils, @virtualbox, @vpn, @wine, @x11-core, @x11-extras, @x11-utils
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe -fomit-frame-pointer"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/splash /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=native -O2 -pipe -fomit-frame-pointer"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--with-bdeps=y --binpkg-respect-use=y --autounmask=n --complete-graph=y --keep-going"
FCFLAGS="-O2 -pipe"
FEATURES="binpkg-logs distlocks ebuild-locks fakeroot fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync webrsync-gpg xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://mirror.yandex.ru/gentoo-distfiles/ http://trumpetti.atm.tut.fi/gentoo/ http://gentoo.bloodhost.ru/ http://mirror.mdfnet.se/gentoo ftp://mirror.mdfnet.se/gentoo http://gentoo.inode.at/ http://ftp.df.lth.se/pub/gentoo/ http://ftp.uni-erlangen.de/pub/mirrors/gentoo http://ftp.halifax.rwth-aachen.de/gentoo/"
INSTALL_MASK=" /etc/systemd /lib*/systemd /lib*/tmpfiles.d /usr/lib*/systemd /usr/lib*/tmpfiles.d /usr/lib*/python*/test "
LANG="ru_RU.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j5"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac acl acpi alsa amd64 amr apm ares bash-completion bidi branding bzip2 c++0x cairo caps cdda cdio cdr cleartype cli consolekit cracklib crypt cue cups custom-cflags custom-optimization cxx dbus dga dirac dri dts dvd dvdr emboss encode exif faad fam fbcon ffmpeg filecaps firefox flac fontconfig fontforge freetype fribidi gcrypt gif glamor gme gmp gnutls gpm gtk gtkstyle iconv icu idn imlib inotify ipv6 jadetex jpeg kde lcms libass libdvdcss lzma lzo mad matroska midi mmap mng modules mp3 mp4 mpeg mpi multilib ncurses network nfs nls nptl offensive ogg openal opengl openmp pango pch pcmcia pcntl pcre pdf pic plasma png policykit posix postproc ppds private-headers projectm qt3support qt5 raw readline schroedinger seccomp session sftp sndfile sockets spell ssl startup-notification svg system-cairo system-harfbuzz system-icu system-jpeg system-libevent system-libvpx system-sqlite tcpd tga theora threads tiff truetype udev udisks unicode upower usb utils vaapi vdpau vorbis vpx wavpack wma wxwidgets x264 xattr xcb xcomposite xft xinerama xpm xscreensaver xv xvid zlib" ABI_X86="64 32" ALSA_CARDS="hda-intel" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="mmx mmxext sse sse2 sse3 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="evdev" KERNEL="linux" L10N="ru en" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="ru en ru_RU en_US" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_4 python3_5" QEMU_SOFTMMU_TARGETS="i386 x86_64" QEMU_USER_TARGETS="i386 x86_64" RUBY_TARGETS="ruby21" SANE_BACKENDS="hp" USERLAND="GNU" VIDEO_CARDS="vesa vga nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
USE_PYTHON="2.7 3.4"
Unset:  CC, CPPFLAGS, CTARGET, CXX, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

=================================================================
                        Package Settings
=================================================================

app-portage/gentoolkit-0.3.3::gentoo was built with the following:
USE="" ABI_X86="64" PYTHON_TARGETS="python2_7 python3_4 python3_5 -pypy"